/***************************************************************************
                          cbytearray.cpp  -  description
                             -------------------
    begin                : Fri Mar 22 2002
    copyright            : (C) 2002-2003 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cbytearray.h"

/** */
CByteArray::CByteArray( unsigned long nSize )
{
	m_pchBuffer = 0;

	Clear();

	SetSize(nSize);
}

/** */
CByteArray::~CByteArray()
{
	Clear();
}

/** */
void CByteArray::Clear()
{
	if (m_pchBuffer)
	{
		free(m_pchBuffer);
	}

	m_pchBuffer   = 0;
	m_nSize       = 0;
	m_nBufferSize = 0;
}

/** */
void CByteArray::SetSize( unsigned long nNewSize )
{
	Clear();

	if( nNewSize > 0 )
	{
		m_pchBuffer = (unsigned char*)malloc(nNewSize);

		if( m_pchBuffer == 0 )
		{
			printf("CByteArray::SetSize: internal memory error\n");
		}
		else
		{
			m_nSize = m_nBufferSize = nNewSize;
		}
	}
}

/** */
void CByteArray::Append( const unsigned char * pchSrc, unsigned long nSize )
{
	unsigned char *p;

	if( nSize == 0 )
	{
		printf("CByteArray::Append: len: %ld\n",nSize);
		return;
	}

	if( !pchSrc )
	{
		printf("CByteArray::Append: null pointer\n");
		return;
	}

	if ( (m_nSize+nSize) > m_nBufferSize )
	{
		m_nBufferSize += nSize + 10000;
		p = (unsigned char*) realloc(m_pchBuffer,m_nBufferSize);

		if( p == 0 )
		{
			printf("CByteArray::Append: fatal error in cbytearray\n");
			return;
		}

		m_pchBuffer = p;
	}

	memcpy( m_pchBuffer+m_nSize, pchSrc, nSize );
	m_nSize += nSize;
}
