/***************************************************************************
                          clisten.cpp  -  description
                             -------------------
    begin                : Fri Mar 22 2002
    copyright            : (C) 2002-2003 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef WIN32
#include <unistd.h>
#endif

#include <dclib/dcos.h>
#include <dclib/core/cmanager.h>
#include "clisten.h"

/** */
CListen::CListen()
{
	m_pListenCallback = 0;
	m_pCallback = 0;
}

/** */
CListen::~CListen()
{
	Disconnect();

	if ( m_pListenCallback )
	{
		delete m_pListenCallback;
		m_pListenCallback = 0;
	}
}

/** */
int CListen::StartListen( int port, CString ip, bool manager )
{
	if ( (CManager::Instance() == 0) && (manager) )
	{
		return -1;
	}

	if ( Listen( port, ip ) != 0 )
	{
		return -1;
	}

	if ( manager )
	{
		m_pCallback = new CCallback<CListen>( this, &CListen::Callback );
		CManager::Instance()->Add( m_pCallback );
	}

	return 0;
}

/** */
void CListen::StopListen()
{
	if ( (m_pCallback) && (CManager::Instance()) )
	{
		CManager::Instance()->Remove( m_pCallback );
		delete m_pCallback;
		m_pCallback = 0;
	}

	Disconnect();
}

/** */
int CListen::Callback( CObject *, CObject * )
{
	int fd;
    
	fd = Accept();
    
	if ( fd != -1 )
	{
		if ( m_pListenCallback != 0 )
		{
			m_pListenCallback->notify(this,(CObject*)&fd);
		}
		else
		{
			DC_ListenCallBack(fd);
		}
	}

	return 0;
}

